# Class PostMethodWebRequest

java.lang.Object
com.meterware.httpunit.WebRequest
com.meterware.httpunit.MessageBodyWebRequest
com.meterware.httpunit.PostMethodWebRequest

public class PostMethodWebRequest extends MessageBodyWebRequest
An HTTP request using the POST method.

## Nested Class Summary

### Nested classes/interfaces inherited from class MessageBodyWebRequest

`MessageBodyWebRequest.InputStreamMessageBody`

## Field Summary

### Fields inherited from class MessageBodyWebRequest

`_body`

### Fields inherited from class WebRequest

`method`

## Constructor Summary

Constructors
Constructor
Description
`PostMethodWebRequest(String urlString)`
Constructs a web request using a specific absolute url string.
`PostMethodWebRequest(String urlString, boolean mimeEncoded)`
Constructs a web request using a specific absolute url string, with optional mime encoding.
`PostMethodWebRequest(String urlString, InputStream source, String contentType)`
Constructs a web request using a specific absolute url string and input stream.
`PostMethodWebRequest(URL urlBase, String urlString, String target)`
Constructs a web request with a specific target.
`PostMethodWebRequest(URL urlBase, String urlString, String target, boolean mimeEncoded)`
Constructs a web request with a specific target, with optional mime encoding.

## Method Summary

Modifier and Type
Method
Description
`protected com.meterware.httpunit.protocol.MessageBody`
`getMessageBody()`
Subclasses may override this method to provide a message body for the request.
`String`
`getMethod()`
Returns the HTTP method defined for this request.
`String`
`getQueryString()`
Returns the query string defined for this request.
`protected boolean`
`maySelectFile(String parameterName)`
Returns true if selectFile may be called with this parameter.

### Methods inherited from class MessageBodyWebRequest

`completeRequest, getContentType, isMimeEncoded, writeMessageBody`

### Methods inherited from class WebRequest

`getCharacterSet, getHeaders, getParameter, getParameterHolder, getParameterValues, getRequestParameterNames, getTarget, getURL, getURLBase, getURLString, isFileParameter, removeParameter, selectFile, selectFile, selectFile, setHeaderField, setImageButtonClickPosition, setParameter, setParameter, setParameter, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### PostMethodWebRequest

public PostMethodWebRequest(String urlString)
Constructs a web request using a specific absolute url string.

### PostMethodWebRequest

public PostMethodWebRequest(String urlString, boolean mimeEncoded)
Constructs a web request using a specific absolute url string, with optional mime encoding.

### PostMethodWebRequest

public PostMethodWebRequest(URL urlBase, String urlString, String target)
Constructs a web request with a specific target.

### PostMethodWebRequest

public PostMethodWebRequest(URL urlBase, String urlString, String target, boolean mimeEncoded)
Constructs a web request with a specific target, with optional mime encoding.

### PostMethodWebRequest

public PostMethodWebRequest(String urlString, InputStream source, String contentType)
Constructs a web request using a specific absolute url string and input stream.

Parameters:
  `urlString` - the URL to which the request should be issued
  `source` - an input stream which will provide the body of this request
  `contentType` - the MIME content type of the body, including any character set

## Method Details

### getMethod

public String getMethod()
Returns the HTTP method defined for this request.

Overrides:
  `getMethod` in class `WebRequest`
Returns:
  the method

### getQueryString

public String getQueryString()
Returns the query string defined for this request.

Overrides:
  `getQueryString` in class `WebRequest`

### maySelectFile

protected boolean maySelectFile(String parameterName)
Returns true if selectFile may be called with this parameter.

Overrides:
  `maySelectFile` in class `WebRequest`

### getMessageBody

protected com.meterware.httpunit.protocol.MessageBody getMessageBody()
Description copied from class: `MessageBodyWebRequest`
Subclasses may override this method to provide a message body for the request.

Overrides:
  `getMessageBody` in class `MessageBodyWebRequest`